org.apache.commons.math3.optimization.direct

## Class SimplexOptimizer

- java.lang.Object
- - org.apache.commons.math3.optimization.direct.BaseAbstractMultivariateOptimizer<MultivariateFunction>
  - - org.apache.commons.math3.optimization.direct.SimplexOptimizer

- All Implemented Interfaces:
    BaseMultivariateOptimizer<MultivariateFunction>, BaseOptimizer<PointValuePair>, MultivariateOptimizer

  Deprecated.
  As of 3.1 (to be removed in 4.0).

      @Deprecated
      public class SimplexOptimizer
      extends BaseAbstractMultivariateOptimizer<MultivariateFunction>
      implements MultivariateOptimizer

  This class implements simplex-based direct search optimization.

  Direct search methods only use objective function values, they do not need derivatives and don't either try to compute approximation of the derivatives. According to a 1996 paper by Margaret H. Wright (Direct Search Methods: Once Scorned, Now Respectable), they are used when either the computation of the derivative is impossible (noisy functions, unpredictable discontinuities) or difficult (complexity, computation cost). In the first cases, rather than an optimum, a not too bad point is desired. In the latter cases, an optimum is desired but cannot be reasonably found. In all cases direct search methods can be useful.

  Simplex-based direct search methods are based on comparison of the objective function values at the vertices of a simplex (which is a set of n+1 points in dimension n) that is updated by the algorithms steps.

  The `setSimplex` method must be called prior to calling the `optimize` method.

  Each call to `optimize` will re-use the start configuration of the current simplex and move it such that its first vertex is at the provided start point of the optimization. If the `optimize` method is called to solve a different problem and the number of parameters change, the simplex must be re-initialized to one with the appropriate dimensions.

  Convergence is checked by providing the worst points of previous and current simplex to the convergence checker, not the best ones.

  This simplex optimizer implementation does not directly support constrained optimization with simple bounds, so for such optimizations, either a more dedicated method must be used like `CMAESOptimizer` or `BOBYQAOptimizer`, or the optimized method must be wrapped in an adapter like `MultivariateFunctionMappingAdapter` or `MultivariateFunctionPenaltyAdapter`.

  Since:
    3.0
  Version:
    $Id: SimplexOptimizer.java 1422230 2012-12-15 12:11:13Z erans $
  See Also:
    `AbstractSimplex`, `MultivariateFunctionMappingAdapter`, `MultivariateFunctionPenaltyAdapter`, `CMAESOptimizer`, `BOBYQAOptimizer`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private AbstractSimplex` | `simplex` Deprecated. Simplex.

    - ### Fields inherited from class org.apache.commons.math3.optimization.direct.BaseAbstractMultivariateOptimizer

      `evaluations`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimplexOptimizer()` Deprecated. See `SimpleValueChecker.SimpleValueChecker()`
    `SimplexOptimizer(ConvergenceChecker<PointValuePair> checker)` Deprecated.
    `SimplexOptimizer(double rel, double abs)` Deprecated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected PointValuePair` | `doOptimize()` Deprecated. Perform the bulk of the optimization algorithm.
    `protected PointValuePair` | `optimizeInternal(int maxEval, MultivariateFunction f, GoalType goalType, OptimizationData... optData)` Deprecated. Optimize an objective function.
    `private void` | `parseOptimizationData(OptimizationData... optData)` Deprecated. Scans the list of (required and optional) optimization data that characterize the problem.
    `void` | `setSimplex(AbstractSimplex simplex)` Deprecated. As of 3.1. The initial simplex can now be passed as an argument of the `BaseAbstractMultivariateOptimizer.optimize(int,MultivariateFunction,GoalType,OptimizationData[])` method.

    - ### Methods inherited from class org.apache.commons.math3.optimization.direct.BaseAbstractMultivariateOptimizer

      `computeObjectiveValue, getConvergenceChecker, getEvaluations, getGoalType, getLowerBound, getMaxEvaluations, getStartPoint, getUpperBound, optimize, optimize, optimizeInternal`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.math3.optimization.BaseMultivariateOptimizer

      `optimize`

    - ### Methods inherited from interface org.apache.commons.math3.optimization.BaseOptimizer

      `getConvergenceChecker, getEvaluations, getMaxEvaluations`

- - ### Field Detail

    - #### simplex

          private AbstractSimplex simplex

      Deprecated.
      Simplex.

  - ### Constructor Detail

    - #### SimplexOptimizer

          @Deprecated
          public SimplexOptimizer()

      Deprecated. See `SimpleValueChecker.SimpleValueChecker()`
      Constructor using a default `convergence checker`.

    - #### SimplexOptimizer

          public SimplexOptimizer(ConvergenceChecker<PointValuePair> checker)

      Deprecated.
      Parameters:
        `checker` - Convergence checker.

    - #### SimplexOptimizer

          public SimplexOptimizer(double rel,
                          double abs)

      Deprecated.
      Parameters:
        `rel` - Relative threshold.
        `abs` - Absolute threshold.

  - ### Method Detail

    - #### setSimplex

          @Deprecated
          public void setSimplex(AbstractSimplex simplex)

      Deprecated. As of 3.1. The initial simplex can now be passed as an argument of the `BaseAbstractMultivariateOptimizer.optimize(int,MultivariateFunction,GoalType,OptimizationData[])` method.
      Set the simplex algorithm.
      Parameters:
        `simplex` - Simplex.

    - #### optimizeInternal

          protected PointValuePair optimizeInternal(int maxEval,
                                        MultivariateFunction f,
                                        GoalType goalType,
                                        OptimizationData... optData)

      Deprecated.
      Optimize an objective function.
      Overrides:
        `optimizeInternal` in class `BaseAbstractMultivariateOptimizer<MultivariateFunction>`
      Parameters:
        `maxEval` - Allowed number of evaluations of the objective function.
        `f` - Objective function.
        `goalType` - Optimization type.
        `optData` - Optimization data. The following data will be looked for:
        - `InitialGuess`
        - `AbstractSimplex`
      Returns:
        the point/value pair giving the optimal value for objective function.

    - #### parseOptimizationData

          private void parseOptimizationData(OptimizationData... optData)

      Deprecated.
      Scans the list of (required and optional) optimization data that characterize the problem.
      Parameters:
        `optData` - Optimization data. The following data will be looked for:
        - `AbstractSimplex`

    - #### doOptimize

          protected PointValuePair doOptimize()

      Deprecated.
      Perform the bulk of the optimization algorithm.
      Specified by:
        `doOptimize` in class `BaseAbstractMultivariateOptimizer<MultivariateFunction>`
      Returns:
        the point/value pair giving the optimal value of the objective function.

Copyright (c) 2003-2013 Apache Software Foundation